/*    [-*- C++ -*-] */
/*
THE COMPUTER CODE CONTAINED HEREIN IS THE SOLE PROPERTY OF PARALLAX
SOFTWARE CORPORATION ("PARALLAX").  PARALLAX, IN DISTRIBUTING THE CODE TO
END-USERS, AND SUBJECT TO ALL OF THE TERMS AND CONDITIONS HEREIN, GRANTS A
ROYALTY-FREE, PERPETUAL LICENSE TO SUCH END-USERS FOR USE BY SUCH END-USERS
IN USING, DISPLAYING,  AND CREATING DERIVATIVE WORKS THEREOF, SO LONG AS
SUCH USE, DISPLAY OR CREATION IS FOR NON-COMMERCIAL, ROYALTY OR REVENUE
FREE PURPOSES.  IN NO EVENT SHALL THE END-USER USE THE COMPUTER CODE
CONTAINED HEREIN FOR REVENUE-BEARING PURPOSES.  THE END-USER UNDERSTANDS
AND AGREES TO THE TERMS HEREIN AND ACCEPTS THE SAME BY USE OF THIS FILE.  
COPYRIGHT 1993-1998 PARALLAX SOFTWARE CORPORATION.  ALL RIGHTS RESERVED.
*/
/*
 * $Source: Smoke:miner:source:bios::RCS:timer.c $
 * $Revision: 1.7 $
 * $Author: allender $
 * $Date: 1995/09/13 08:38:08 $
 * 
 * Functions for timers.
 * 
 * $Log: timer.c $
 * Revision 1.7  1995/09/13  08:38:08  allender
 * added control macros and put in correct support for 68k
 *
 * Revision 1.6  1995/08/31  14:40:09  allender
 * multiply by F1_0/160 instead of dividing
 *
 * Revision 1.5  1995/05/15  13:55:52  allender
 * change prototype for timer_proc
 *
 * Revision 1.4  1995/05/11  13:06:07  allender
 * remove a5 references under PowerPC code
 *
 * Revision 1.3  1995/05/04  20:03:03  allender
 * added two functions, timer_approx_seconds, and delay
 *
 * Revision 1.2  1995/03/21  13:40:01  allender
 * *** empty log message ***
 *
 * Revision 1.1  1995/03/21  13:31:33  allender
 * Initial revision
 *
 */
 
#include "dtypes.h"
#include "gtimer.h"

//For timeval struct and gettimeofday:
#include <sys/time.h>
#include <unistd.h>

#include "debug.h"

#define COUNTER_TIME	-6250
#define COUNTER_RATE	160
#define INV_TIMER_COUNT	0.00625

static int Installed = 0;
static uint timer_count;

//timer_info ctimer_info;

struct timeval old_tv;




//F1_0=f1_0=0x10000 =65536
//fix=32 bit of which 16 bit is fraction
fix timer_get_approx_seconds()
{
	int x;

	x = timer_count;
//#ifdef __powerc
//	return (fix)(((double)x * INV_TIMER_COUNT) * F1_0);
//#else
//	return fixmuldiv(x, 65536, COUNTER_RATE);
//#endif

	return timer_get_fixed_seconds();
}

fix timer_get_fixed_seconds()
{
	int x;

//	_disable_timer();	
//	x = timer_count;
//	_enable_timer();
//#ifdef __powerc
//	return (fix)(((double)x * INV_TIMER_COUNT) * F1_0);
//#else
//	return fixmuldiv(x, 65536, COUNTER_RATE);
//#endif

	//Ye good olde unix:
	struct timeval tv_now;
	gettimeofday(&tv_now, NULL);
	x=(tv_now.tv_sec-old_tv.tv_sec)*F1_0+fixmuldiv(tv_now.tv_usec-old_tv.tv_usec, 65536, 1000000); //old_tv=inital statup value
//	x=(tv_now.tv_sec-old_tv.tv_sec-1)*F1_0+fixmuldiv(tv_now.tv_usec-old_tv.tv_usec+1000000, 65536, 1000000); //old_tv=inital statup value

       /* //65536 seconds gives 1092 hours. Should be enough for most players :) */
	return x;
}

void delay(int d_time)
{
	fix t, total;
	
	total = (F1_0 * d_time) / 1000;
	t = timer_get_fixed_seconds();
	while (timer_get_fixed_seconds() - t < total) ;

DEB1(printf("delay\n"));
}



void timer_close()
{
	if (!Installed)
		return;

//	RmvTime((QElemPtr)(&ctimer_info));
//	_disable_timer();

	Installed = 0;
}

void timer_init()
{
//	long tm_ver;

	if (Installed)
		return;

	if (Installed)
		return;
	Installed = 1;		

// Use itimer to set a timer task with a rate equal to the PC timer? (mac version does this but gettimeofday is nicer or not?)

	gettimeofday(&old_tv, 0);

DEB1(printf("timer init\n"));
}
