/*
THE COMPUTER CODE CONTAINED HEREIN IS THE SOLE PROPERTY OF PARALLAX
SOFTWARE CORPORATION ("PARALLAX").  PARALLAX, IN DISTRIBUTING THE CODE TO
END-USERS, AND SUBJECT TO ALL OF THE TERMS AND CONDITIONS HEREIN, GRANTS A
ROYALTY-FREE, PERPETUAL LICENSE TO SUCH END-USERS FOR USE BY SUCH END-USERS
IN USING, DISPLAYING,  AND CREATING DERIVATIVE WORKS THEREOF, SO LONG AS
SUCH USE, DISPLAY OR CREATION IS FOR NON-COMMERCIAL, ROYALTY OR REVENUE
FREE PURPOSES.  IN NO EVENT SHALL THE END-USER USE THE COMPUTER CODE
CONTAINED HEREIN FOR REVENUE-BEARING PURPOSES.  THE END-USER UNDERSTANDS
AND AGREES TO THE TERMS HEREIN AND ACCEPTS THE SAME BY USE OF THIS FILE.  
COPYRIGHT 1993-1998 PARALLAX SOFTWARE CORPORATION.  ALL RIGHTS RESERVED.
*/
/*
 * $Source: Smoke:miner:source:main::RCS:songs.c $
 * $Revision: 1.5 $
 * $Author: allender $
 * $Date: 1995/11/03 12:52:59 $
 * 
 * Routines to manage the songs in Descent.
 * 
 * $Log: songs.c $
 * Revision 1.5  1995/11/03  12:52:59  allender
 * shareware changes
 *
 * Revision 1.4  1995/10/18  01:51:33  allender
 * fixed up stuff for redbook
 *
 * Revision 1.3  1995/10/17  13:13:44  allender
 * dont' add resource value to songs to play -- now done in digi
 * code
 *
 * Revision 1.2  1995/07/17  08:50:35  allender
 * make work with new music system
 *
 * Revision 1.1  1995/05/16  15:31:05  allender
 * Initial revision
 *
 * Revision 2.0  1995/02/27  11:27:13  john
 * New version 2.0, which has no anonymous unions, builds with
 * Watcom 10.0, and doesn't require parsing BITMAPS.TBL.
 * 
 * Revision 1.2  1995/02/11  12:42:12  john
 * Added new song method, with FM bank switching..
 * 
 * Revision 1.1  1995/02/11  10:20:33  john
 * Initial revision
 * 
 * 
 */



#include <stdlib.h>
#include <string.h>

#include "error.h"
#include "dtypes.h"
#include "songs.h"
#include "mono.h"
#include "cfile.h"
#include "strutil.h"
#include "digi.h"

#define DEBUG
#include <debug.h>
#include <stdio.h>

ubyte shuffle_levels = 0;

#ifndef SHAREWARE_10
song_info Songs[MAX_SONGS];
#else
song_info Songs[MAX_SONGS]={
	"descent.hmp",  "hammelo.bnk", "hamdrum.bnk",
	"briefing.hmp", "melodic.bnk", "drum.bnk",
/*	"endlevel.hmp", "intmelo.bnk", "intdrum.bnk",*/ /* Not is SW */
/*	"endgame.hmp",  "intmelo.bnk", "intdrum.bnk",*/ /* Not is SW */
	"credits.hmp",  "melodic.bnk", "drum.bnk",
	"game0.hmp",    "hammelo.bnk", "hamdrum.bnk",
	"game1.hmp",    "hammelo.bnk", "hamdrum.bnk",
	"game2.hmp",    "intmelo.bnk", "intdrum.bnk",
	"game3.hmp",    "melodic.bnk", "drum.bnk",
	"game4.hmp",    "melodic.bnk", "drum.bnk",
};
#endif
int Songs_initialized = 0;

void songs_init()
{
#ifdef PC_REGISTERED_15
#ifndef SHAREWARE_10
	int i;
	char inputline[80+1];
	CFILE * fp;

	if ( Songs_initialized ) return;

	fp = cfopen( "descent.sng", "rb" );
	if ( fp == NULL )	{
		Error( "Couldn't open descent.sng" );
	}

	i = 0;
	while (cfgets(inputline, 80, fp )) {
//		char *p = strchr(inputline,'\n');
//		if (p) *p = '\0';
		strcutcrlf(inputline);
	if ( strlen( inputline ) )	{
			Assert( i < MAX_SONGS );
			sscanf( inputline, "%s %s %s", Songs[i].filename, Songs[i].melodic_bank_file, Songs[i].drum_bank_file );
DEB1(printf( "%d. '%s' '%s' '%s'\n",i,  Songs[i].filename, Songs[i].melodic_bank_file, Songs[i].drum_bank_file ));
			i++;
		}
	}
	cfclose(fp);
#if 0 /* My test stuff */
DEB1(
	{
		 FILE *fp2; unsigned char bb; int llen;
		 fp = cfopen( "descent.hmq", "rb" );
		 if ( fp == NULL )	{
			 Error( "Couldn't open descent.hmq" );
		 }
		 fp2=fopen("/home/wouter/a-descent.hmq", "wb" );
cfseek(fp, 0, SEEK_END);
		 llen=cftell(fp);
cfseek(fp, 0, SEEK_SET);

printf("llen=%0x\n", llen);
		 for (i=0;i<llen;i++) {
			 if (cfread( &bb, 1, 1, fp )==0) break;
			 fwrite( &bb, 1, 1, fp2);
		 }
		 cfclose(fp);
		 fclose(fp2);

		 fp = cfopen( "descent.hmp", "rb" );
		 if ( fp == NULL )	{
			 Error( "Couldn't open descent.hmp" );
		 }
		 fp2=fopen("/home/wouter/a-descent.hmp", "wb" );
cfseek(fp, 0, SEEK_END);
		 llen=cftell(fp);
cfseek(fp, 0, SEEK_SET);
		 for (i=0;i<llen;i++) {
			 if (cfread( &bb, 1, 1, fp )==0) break;
			 fwrite( &bb, 1, 1, fp2);
		 }
		 cfclose(fp);
		 fclose(fp2);
	}
)
#endif /* if 0, this is WHS test junk :-) */
#endif
#endif
	Songs_initialized = 1;
}


void songs_play_song( int songnum, int repeat )
{
	if ( !Songs_initialized ) songs_init();
#ifdef USE_SOUND
	digi_play_midi_song( songnum, repeat );
#endif
}

void songs_play_level_song( int levelnum )
{
	int songnum;

	Assert( levelnum != 0 );

	if ( !Songs_initialized ) songs_init();
	
#ifdef MAC_SHAREWARE
	songnum = levelnum-1;
#else
	if (!shuffle_levels) {
		if (levelnum < 0)
			songnum = (-levelnum) % NUM_GAME_SONGS;
		else
			songnum = (levelnum-1) % NUM_GAME_SONGS;
	} else
		songnum = rr_rand() % NUM_GAME_SONGS;
#endif


	songnum += SONG_LEVEL_MUSIC;
#ifdef USE_SOUND
	digi_play_midi_song( songnum, 1 );
#endif
}
